/***************************************************************************
 *                       SettingsDlg.cpp  -  description
 *                               -------------------
 *  begin                : Tue Sep 10 10:40:21 BST 2002
 *  copyright            : (C) 2002 by Dmitri Skachkov
 *  email                : d_skachkov@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "SettingsDlg.h"
#include "toUnicode.h"
#include <qlayout.h>
#include <qlistview.h>
#include <qdir.h>
#include <qlabel.h>
#include <qtextcodec.h>
#include <qfontdatabase.h> 
#include <qtabwidget.h>
#include <qabstractlayout.h>
#include <qregexp.h>
#ifndef __FOR_QT__
#include <qpe/resource.h>
#endif
#include <qpalette.h>

SettingsDlg::SettingsDlg(QWidget *parent, const char *name)
    : QWidget(parent, name)
{
    if ( !name )
	setName( "SettingsDlg" );
    SettingsDlgLayout = new QVBoxLayout( this, 0, 0); 

    settingsTab = new QTabWidget( this);

    tab = new QWidget( settingsTab, "tab" );

    QWidget* privateLayoutWidget = new QWidget( tab );
    privateLayoutWidget->setGeometry( QRect( 0, 0, 240, 237 ) );
    displayTabLayout = new QVBoxLayout( privateLayoutWidget, 1, 1); 

    fontLayout = new QHBoxLayout( 0, 1, 1); 

    fontLayoutLeft = new QVBoxLayout( 0, 1, 1); 

    TextLabel1 = new QLabel( privateLayoutWidget );
    fontLayoutLeft->addWidget( TextLabel1 );

    fontNameLayout = new QHBoxLayout( 0, 0, 0);

    fontNameComboBox = new QComboBox( FALSE, privateLayoutWidget );
    fontNameComboBox->setMaximumWidth(120);
    fontNameLayout->addWidget(fontNameComboBox);
    QSpacerItem* fontNameSpacer = new QSpacerItem( 10, 10, QSizePolicy::Expanding, QSizePolicy::Minimum );
    fontNameLayout->addItem( fontNameSpacer );
    fontLayoutLeft->addLayout( fontNameLayout );

    TextLabel2 = new QLabel( privateLayoutWidget );
    fontLayoutLeft->addWidget( TextLabel2 );

    fontSizeLayout = new QHBoxLayout( 0, 0, 0); 

    fontSizeSpinBox = new QSpinBox( privateLayoutWidget );
    fontSizeSpinBox->setMinValue(8);
    fontSizeSpinBox->setMaxValue(24);
    fontSizeSpinBox->setLineStep(1);
    fontSizeLayout->addWidget( fontSizeSpinBox );
    QSpacerItem* spacer = new QSpacerItem( 10, 10, QSizePolicy::Expanding, QSizePolicy::Minimum );
    fontSizeLayout->addItem( spacer );
    fontLayoutLeft->addLayout( fontSizeLayout );
    fontLayout->addLayout( fontLayoutLeft );

    fontLayoutRight = new QVBoxLayout( 0, 1, 1); 

    fontBoldCheckBox = new QCheckBox( privateLayoutWidget );
    fontLayoutRight->addWidget( fontBoldCheckBox );

    fakeBoldCheckBox = new QCheckBox( privateLayoutWidget );
    fontLayoutRight->addWidget( fakeBoldCheckBox );

    fontItalicCheckBox = new QCheckBox( privateLayoutWidget );
    fontLayoutRight->addWidget( fontItalicCheckBox );
    QSpacerItem* spacer_2 = new QSpacerItem( 20, 10, QSizePolicy::Minimum, QSizePolicy::Expanding );
    fontLayoutRight->addItem( spacer_2 );
    fontLayout->addLayout( fontLayoutRight );
    displayTabLayout->addLayout( fontLayout );

    rotateAlignLayout = new QHBoxLayout( 0, 1, 1); 

    TextLabel3 = new QLabel( privateLayoutWidget );
    rotateAlignLayout->addWidget( TextLabel3 );

    rotationComboBox = new QComboBox( FALSE, privateLayoutWidget );
    rotationComboBox->setMaximumSize( QSize( 48, 32767 ) );
    rotateAlignLayout->addWidget( rotationComboBox );

    TextLabel4 = new QLabel( privateLayoutWidget );
    rotateAlignLayout->addWidget( TextLabel4 );

    alignComboBox = new QComboBox( FALSE, privateLayoutWidget );
    rotateAlignLayout->addWidget( alignComboBox );
    displayTabLayout->addLayout( rotateAlignLayout );

    numbersLayout = new QGridLayout( 0, 1, 1, 1, 1); 

    marginsSpinBox = new QSpinBox( privateLayoutWidget );
    marginsSpinBox->setMinValue(0);
    marginsSpinBox->setMaxValue(40);
    marginsSpinBox->setLineStep(1);
    marginsSpinBox->setMaximumSize( QSize( 37, 32767 ) );

    numbersLayout->addWidget( marginsSpinBox, 1, 1 );

    TextLabel9 = new QLabel( privateLayoutWidget );

    numbersLayout->addWidget( TextLabel9, 1, 2 );

    overlapSpinBox = new QSpinBox( privateLayoutWidget );
    overlapSpinBox->setMinValue(0);
    overlapSpinBox->setMaxValue(5);
    overlapSpinBox->setLineStep(1);
    overlapSpinBox->setMaximumSize( QSize( 44, 32767 ) );

    numbersLayout->addWidget( overlapSpinBox, 0, 3 );

    imageScalingSpinBox = new QSpinBox( privateLayoutWidget );
    imageScalingSpinBox->setMinValue(10);
    imageScalingSpinBox->setMaxValue(100);
    imageScalingSpinBox->setLineStep(5);
    imageScalingSpinBox->setMaximumSize( QSize( 44, 32767 ) );

    numbersLayout->addWidget( imageScalingSpinBox, 1, 3 );

    spacingSpinBox = new QSpinBox( privateLayoutWidget );
    spacingSpinBox->setMinValue(0);
    spacingSpinBox->setMaxValue(10);
    spacingSpinBox->setLineStep(1);
    spacingSpinBox->setMaximumSize( QSize( 37, 32767 ) );

    numbersLayout->addWidget( spacingSpinBox, 2, 1 );

    TextLabel7 = new QLabel( privateLayoutWidget );

    numbersLayout->addWidget( TextLabel7, 2, 0 );

    TextLabel5 = new QLabel( privateLayoutWidget );

    numbersLayout->addWidget( TextLabel5, 0, 0 );

    scrollSpinBox = new QSpinBox( privateLayoutWidget );
    scrollSpinBox->setMinValue(5);
    scrollSpinBox->setMaxValue(1000);
    scrollSpinBox->setLineStep(5);
    scrollSpinBox->setMaximumSize( QSize( 44, 32767 ) );

    numbersLayout->addWidget( scrollSpinBox, 2, 3 );

    indentSpinBox = new QSpinBox( privateLayoutWidget );
    indentSpinBox->setMinValue(0);
    indentSpinBox->setMaxValue(40);
    indentSpinBox->setLineStep(1);
    indentSpinBox->setMaximumSize( QSize( 37, 32767 ) );

    numbersLayout->addWidget( indentSpinBox, 0, 1 );

    TextLabel8 = new QLabel( privateLayoutWidget );

    numbersLayout->addWidget( TextLabel8, 0, 2 );

    TextLabel6 = new QLabel( privateLayoutWidget );

    numbersLayout->addWidget( TextLabel6, 1, 0 );

    TextLabel10 = new QLabel( privateLayoutWidget );

    numbersLayout->addWidget( TextLabel10, 2, 2 );
    displayTabLayout->addLayout( numbersLayout );

    barImagesChecksLayout = new QVBoxLayout( 0, 1, 1); 

    barCheckBox = new QCheckBox( privateLayoutWidget );
    barImagesChecksLayout->addWidget( barCheckBox );

    barPercentCheckBox = new QCheckBox( privateLayoutWidget );
    barImagesChecksLayout->addWidget( barPercentCheckBox );
    
    imageAsWordCheckBox = new QCheckBox( privateLayoutWidget );
    barImagesChecksLayout->addWidget( imageAsWordCheckBox );
    displayTabLayout->addLayout( barImagesChecksLayout );
    settingsTab->insertTab( tab, "" );

    tab_2 = new QWidget( settingsTab, "tab_2" );

    QWidget* privateLayoutWidget_2 = new QWidget( tab_2 );
    privateLayoutWidget_2->setGeometry( QRect( 0, 0, 250, 139 ) );
    formatTabLayout = new QHBoxLayout( privateLayoutWidget_2, 1, 1); 

    formatCombosLayout = new QVBoxLayout( 0, 1, 1); 

    TextLabel1_2 = new QLabel( privateLayoutWidget_2 );
    formatCombosLayout->addWidget( TextLabel1_2 );

    encodingComboBox = new QComboBox( FALSE, privateLayoutWidget_2 );
    encodingComboBox->setMaximumWidth(100);
    formatCombosLayout->addWidget( encodingComboBox );

    TextLabel2_2 = new QLabel( privateLayoutWidget_2 );
    formatCombosLayout->addWidget( TextLabel2_2 );

    docFormatComboBox = new QComboBox( FALSE, privateLayoutWidget_2);
    docFormatComboBox->setMaximumWidth(100);
    formatCombosLayout->addWidget( docFormatComboBox );

    TextLabel3_2 = new QLabel( privateLayoutWidget_2 );
    formatCombosLayout->addWidget( TextLabel3_2 );

    palmFormatComboBox = new QComboBox( FALSE, privateLayoutWidget_2);
    palmFormatComboBox->setMaximumWidth(100);
    formatCombosLayout->addWidget( palmFormatComboBox );
    formatTabLayout->addLayout( formatCombosLayout );

    formatChecksLayout = new QVBoxLayout( 0, 1, 1); 

    reparagraphCheckBox = new QCheckBox( privateLayoutWidget_2);
    formatChecksLayout->addWidget( reparagraphCheckBox );

    separateParagraphsCheckBox = new QCheckBox( privateLayoutWidget_2);
    formatChecksLayout->addWidget( separateParagraphsCheckBox );

    stripCRCheckBox = new QCheckBox( privateLayoutWidget_2);
    formatChecksLayout->addWidget( stripCRCheckBox );

    removeSpacePadsCheckBox = new QCheckBox( privateLayoutWidget_2);
    formatChecksLayout->addWidget( removeSpacePadsCheckBox );

    reorderPluckerCheckBox = new QCheckBox( privateLayoutWidget_2);
    formatChecksLayout->addWidget( reorderPluckerCheckBox );
    QSpacerItem* spacer_3 = new QSpacerItem( 0, 30, QSizePolicy::Minimum, QSizePolicy::Expanding );
    formatChecksLayout->addItem( spacer_3 );
    formatTabLayout->addLayout( formatChecksLayout );
    settingsTab->insertTab( tab_2, "" );

    tab_3 = new QWidget( settingsTab, "tab_3" );

    QWidget* privateLayoutWidget_3 = new QWidget( tab_3 );
    privateLayoutWidget_3->setGeometry( QRect( 0, 0, 232, 76 ) );
    miscTabLayout = new QVBoxLayout( privateLayoutWidget_3, 1, 1); 

    intDictCheckBox = new QCheckBox( privateLayoutWidget_3);
    miscTabLayout->addWidget( intDictCheckBox );

    dictPathLayout = new QHBoxLayout( 0, 0, 0); 

    textLabel1 = new QLabel( privateLayoutWidget_3 );
    dictPathLayout->addWidget( textLabel1 );

    dictionaryLineEdit = new QLineEdit( privateLayoutWidget_3);
    dictPathLayout->addWidget( dictionaryLineEdit );
    miscTabLayout->addLayout( dictPathLayout );

    dictComboBox = new QComboBox( FALSE, privateLayoutWidget_3);
    dictComboBox->setMinimumSize( QSize( 230, 0 ) );
    miscTabLayout->addWidget( dictComboBox );
    settingsTab->insertTab( tab_3, "" );

    tab_4 = new QWidget( settingsTab);

    QWidget* privateLayoutWidget_4 = new QWidget( tab_4);
    privateLayoutWidget_4->setGeometry( QRect( 0, 0, 176, 175 ) );
    colorsTabLayout = new QGridLayout( privateLayoutWidget_4, 1, 1, 1, 1); 

    barFgColorComboBox = new ColorComboBox( privateLayoutWidget_4);

    colorsTabLayout->addWidget( barFgColorComboBox, 3, 1 );

    TextLabel7_2 = new QLabel( privateLayoutWidget_4 );

    colorsTabLayout->addWidget( TextLabel7_2, 3, 0 );

    TextLabel8_2 = new QLabel( privateLayoutWidget_4 );

    colorsTabLayout->addWidget( TextLabel8_2, 4, 0 );

    TextLabel6_2 = new QLabel( privateLayoutWidget_4 );

    colorsTabLayout->addWidget( TextLabel6_2, 2, 0 );

    TextLabel4_2 = new QLabel( privateLayoutWidget_4 );

    colorsTabLayout->addWidget( TextLabel4_2, 0, 0 );

    barBgColorComboBox = new ColorComboBox(  privateLayoutWidget_4 );

    colorsTabLayout->addWidget( barBgColorComboBox, 4, 1 );

    barTextColorComboBox = new ColorComboBox(  privateLayoutWidget_4 );

    colorsTabLayout->addWidget( barTextColorComboBox, 5, 1 );

    normalColorComboBox = new ColorComboBox(  privateLayoutWidget_4 );

    colorsTabLayout->addWidget( normalColorComboBox, 1, 1 );

    TextLabel9_2 = new QLabel( privateLayoutWidget_4 );

    colorsTabLayout->addWidget( TextLabel9_2, 5, 0 );

    TextLabel5_2 = new QLabel( privateLayoutWidget_4 );

    colorsTabLayout->addWidget( TextLabel5_2, 1, 0 );

    bgColorComboBox = new ColorComboBox(  privateLayoutWidget_4);

    colorsTabLayout->addWidget( bgColorComboBox, 0, 1 );

    linkColorComboBox = new ColorComboBox(  privateLayoutWidget_4);

    colorsTabLayout->addWidget( linkColorComboBox, 2, 1 );
    settingsTab->insertTab( tab_4, "" );

    tab_5 = new QWidget( settingsTab, "tab_5" );

    QWidget* privateLayoutWidget_5 = new QWidget( tab_5);
    privateLayoutWidget_5->setGeometry( QRect( 0, 0, 219, 240 ) );
    controls1TabLayout = new QGridLayout( privateLayoutWidget_5, 1, 1, 1, 1); 

    rotateButton = new SelectKeyButton(  privateLayoutWidget_5);
    rotateButton->setMinimumSize( QSize( 140, 0 ) );
    rotateButton->setMaximumSize( QSize( 140, 32767 ) );

    controls1TabLayout->addWidget( rotateButton, 3, 1 );

    scrollButton = new SelectKeyButton(  privateLayoutWidget_5);
    scrollButton->setMinimumSize( QSize( 140, 0 ) );
    scrollButton->setMaximumSize( QSize( 140, 32767 ) );

    controls1TabLayout->addWidget( scrollButton, 0, 1 );

    TextLabel12 = new QLabel( privateLayoutWidget_5 );

    controls1TabLayout->addWidget( TextLabel12, 2, 0 );

    fullScreenButton = new SelectKeyButton(  privateLayoutWidget_5);
    fullScreenButton->setMinimumSize( QSize( 140, 0 ) );
    fullScreenButton->setMaximumSize( QSize( 140, 32767 ) );

    controls1TabLayout->addWidget( fullScreenButton, 2, 1 );

    TextLabel14 = new QLabel( privateLayoutWidget_5 );

    controls1TabLayout->addWidget( TextLabel14, 4, 0 );

    TextLabel10_2 = new QLabel( privateLayoutWidget_5 );

    controls1TabLayout->addWidget( TextLabel10_2, 0, 0 );

    fileopenButton = new SelectKeyButton(  privateLayoutWidget_5);
    fileopenButton->setMinimumSize( QSize( 140, 0 ) );
    fileopenButton->setMaximumSize( QSize( 140, 32767 ) );

    controls1TabLayout->addWidget( fileopenButton, 5, 1 );

    barButton = new SelectKeyButton(  privateLayoutWidget_5);
    barButton->setMinimumSize( QSize( 140, 0 ) );
    barButton->setMaximumSize( QSize( 140, 32767 ) );

    controls1TabLayout->addWidget( barButton, 1, 1 );

    TextLabel17 = new QLabel( privateLayoutWidget_5 );

    controls1TabLayout->addWidget( TextLabel17, 7, 0 );

    bookmarkButton = new SelectKeyButton(  privateLayoutWidget_5);
    bookmarkButton->setMinimumSize( QSize( 140, 0 ) );
    bookmarkButton->setMaximumSize( QSize( 140, 32767 ) );

    controls1TabLayout->addWidget( bookmarkButton, 6, 1 );

    findButton = new SelectKeyButton(  privateLayoutWidget_5);
    findButton->setMinimumSize( QSize( 140, 0 ) );
    findButton->setMaximumSize( QSize( 140, 32767 ) );

    controls1TabLayout->addWidget( findButton, 7, 1 );

    TextLabel15 = new QLabel( privateLayoutWidget_5 );

    controls1TabLayout->addWidget( TextLabel15, 5, 0 );

    TextLabel11 = new QLabel( privateLayoutWidget_5 );

    controls1TabLayout->addWidget( TextLabel11, 1, 0 );

    TextLabel18 = new QLabel( privateLayoutWidget_5 );

    controls1TabLayout->addWidget( TextLabel18, 8, 0 );

    TextLabel16 = new QLabel( privateLayoutWidget_5 );

    controls1TabLayout->addWidget( TextLabel16, 6, 0 );

    backButton = new SelectKeyButton(  privateLayoutWidget_5);
    backButton->setMinimumSize( QSize( 140, 0 ) );
    backButton->setMaximumSize( QSize( 140, 32767 ) );

    controls1TabLayout->addWidget( backButton, 8, 1 );

    settingsButton = new SelectKeyButton(  privateLayoutWidget_5);
    settingsButton->setMinimumSize( QSize( 140, 0 ) );
    settingsButton->setMaximumSize( QSize( 140, 32767 ) );

    controls1TabLayout->addWidget( settingsButton, 4, 1 );

    TextLabel13 = new QLabel( privateLayoutWidget_5 );

    controls1TabLayout->addWidget( TextLabel13, 3, 0 );
    
    QSpacerItem* controls1Spacer1 = new QSpacerItem( 10, 10, QSizePolicy::Minimum, QSizePolicy::Expanding );
    controls1TabLayout->addItem(controls1Spacer1, 9, 0);
    QSpacerItem* controls1Spacer2 = new QSpacerItem( 10, 10, QSizePolicy::Minimum, QSizePolicy::Expanding );
    controls1TabLayout->addItem(controls1Spacer2, 9, 1);


    
    settingsTab->insertTab( tab_5, "" );

    tab_6 = new QWidget( settingsTab, "tab_6" );

    QWidget* privateLayoutWidget_6 = new QWidget( tab_6);
    privateLayoutWidget_6->setGeometry( QRect( 1, 1, 211, 140 ) );
    controls2TabLayout = new QVBoxLayout( privateLayoutWidget_6, 1, 1); 

    joypadCheckBox = new QCheckBox( privateLayoutWidget_6);
    controls2TabLayout->addWidget( joypadCheckBox );

    directionKeysLayout = new QGridLayout( 0, 1, 1, 1, 1); 

    rightButton = new SelectKeyButton(  privateLayoutWidget_6);
    rightButton->setMinimumSize( QSize( 140, 0 ) );
    rightButton->setMaximumSize( QSize( 140, 32767 ) );

    directionKeysLayout->addWidget( rightButton, 3, 1 );

    leftButton = new SelectKeyButton(  privateLayoutWidget_6);
    leftButton->setMinimumSize( QSize( 140, 0 ) );
    leftButton->setMaximumSize( QSize( 140, 32767 ) );

    directionKeysLayout->addWidget( leftButton, 2, 1 );

    TextLabel20_2_2 = new QLabel( privateLayoutWidget_6 );

    directionKeysLayout->addWidget( TextLabel20_2_2, 1, 0 );

    downButton = new SelectKeyButton(  privateLayoutWidget_6);
    downButton->setMinimumSize( QSize( 140, 0 ) );
    downButton->setMaximumSize( QSize( 140, 32767 ) );

    directionKeysLayout->addWidget( downButton, 1, 1 );

    TextLabel22_2_2 = new QLabel( privateLayoutWidget_6 );

    directionKeysLayout->addWidget( TextLabel22_2_2, 3, 0 );

    TextLabel19_2_2 = new QLabel( privateLayoutWidget_6 );

    directionKeysLayout->addWidget( TextLabel19_2_2, 0, 0 );

    upButton = new SelectKeyButton(  privateLayoutWidget_6);
    upButton->setMinimumSize( QSize( 140, 0 ) );
    upButton->setMaximumSize( QSize( 140, 32767 ) );

    directionKeysLayout->addWidget( upButton, 0, 1 );

    TextLabel21_2_2 = new QLabel( privateLayoutWidget_6 );

    directionKeysLayout->addWidget( TextLabel21_2_2, 2, 0 );
    controls2TabLayout->addLayout( directionKeysLayout );
    QSpacerItem* controls2Spacer1 = new QSpacerItem( 10, 10, QSizePolicy::Minimum, QSizePolicy::Expanding );
    directionKeysLayout->addItem(controls2Spacer1, 9, 0);
    QSpacerItem* controls2Spacer2 = new QSpacerItem( 10, 10, QSizePolicy::Minimum, QSizePolicy::Expanding );
    directionKeysLayout->addItem(controls2Spacer2, 9, 1);


    settingsTab->insertTab( tab_6, "" );

    tab_7 = new QWidget( settingsTab);
    tabLayout = new QVBoxLayout( tab_7, 0, 0); 

    textLabel3 = new QLabel( tab_7 );
    textLabel3->setTextFormat( QLabel::AutoText );
    textLabel3->setFont(QFont("helvetica",12,QFont::Bold,FALSE));
    textLabel3->setAlignment( int( QLabel::WordBreak | QLabel::AlignCenter ) );
    tabLayout->addWidget( textLabel3 );
    settingsTab->insertTab( tab_7, "" );
    SettingsDlgLayout->addWidget( settingsTab );
    languageChange();
    resize( QSize(312, 351).expandedTo(minimumSizeHint()) );


    connect(dictComboBox,SIGNAL(activated( const QString &)),this,SLOT(pathChanged(const QString &)));
    
    QFontDatabase *fontdatabase = new QFontDatabase();
    toUnicode * decoder = new toUnicode();
    QString codecs;
    for(int i=0;i<3000;i++)
    {
	if (QTextCodec::codecForMib(i) == NULL) continue;
	decoder->setCodec((QTextCodec::codecForMib(i))->name());
	if (decoder->Index > -1) continue;
	codecs +=QString((QTextCodec::codecForMib(i))->name())+",";
    }
    codecs += decoder->getCodecList();
    fontNameComboBox->insertStringList(fontdatabase->families(FALSE),-1);
    encodingComboBox->insertStringList(QStringList::split(",",codecs,-1),-1);
    rotationComboBox->insertStringList(QStringList::split(",","0,-90,90,180",-1),-1);
    alignComboBox->insertStringList(QStringList::split(",","Left,Center,Right,Justify",-1),-1);
    docFormatComboBox->insertStringList(QStringList::split(",","Auto,HTML,TXT,XML",-1),-1);
    palmFormatComboBox->insertStringList(QStringList::split(",","Plucker,DOC,HTML,TXT,MobiPocket",-1),-1);
    connect(joypadCheckBox,SIGNAL(clicked()),this,SLOT(joypadChanged()));
    
}

void SettingsDlg::languageChange()
{
    setCaption( tr( "Settings" ) );
    TextLabel1->setText( tr( "Font Name" ) );
    TextLabel2->setText( tr( "Font Size" ) );
    fontBoldCheckBox->setText( tr( "Bold" ) );
    fakeBoldCheckBox->setText( tr( "Use fake Bold" ) );
    fontItalicCheckBox->setText( tr( "Italic" ) );
    TextLabel3->setText( tr( "Rotation" ) );
    TextLabel4->setText( tr( "Align" ) );
    TextLabel9->setText( tr( "Pics scaling" ) );
    TextLabel7->setText( tr( "Spacing" ) );
    TextLabel5->setText( tr( "Indents" ) );
    TextLabel8->setText( tr( "Lines overlap" ) );
    TextLabel6->setText( tr( "Margins" ) );
    TextLabel10->setText( tr( "Scroll delay" ) );
    barCheckBox->setText( tr( "Show progress bar" ) );
    barPercentCheckBox->setText( tr( "Show progress as %" ) );
    imageAsWordCheckBox->setText( tr( "Pack Pics" ) );
    settingsTab->changeTab( tab, tr( "Display" ) );
    TextLabel1_2->setText( tr( "Encoding" ) );
    TextLabel2_2->setText( tr( "Book Format" ) );
    TextLabel3_2->setText( tr( "Palm Format" ) );
    reparagraphCheckBox->setText( tr( "Reparagraph" ) );
    separateParagraphsCheckBox->setText( tr( "Separate paragraphs" ) );
    stripCRCheckBox->setText( tr( "Strip CR(DOS texts)" ) );
    removeSpacePadsCheckBox->setText( tr( "Strip space pads" ) );
    reorderPluckerCheckBox->setText( tr( "Reorder Plucker" ) );
    settingsTab->changeTab( tab_2, tr( "Format" ) );
    intDictCheckBox->setText( tr( "Built-in dictionary" ) );
    textLabel1->setText( tr( "Path:" ) );
    settingsTab->changeTab( tab_3, tr( "Misc" ) );
    TextLabel7_2->setText( tr( "Bar Color1" ) );
    TextLabel8_2->setText( tr( "Bar Color2" ) );
    TextLabel6_2->setText( tr( "Link text" ) );
    TextLabel4_2->setText( tr( "Background" ) );
    TextLabel9_2->setText( tr( "Bar text" ) );
    TextLabel5_2->setText( tr( "Normal text" ) );
    settingsTab->changeTab( tab_4, tr( "Colors" ) );
    TextLabel12->setText( tr( "FullScreen" ) );
    TextLabel14->setText( tr( "Settings" ) );
    TextLabel10_2->setText( tr( "Scroll" ) );
    TextLabel17->setText( tr( "FindWord" ) );
    TextLabel15->setText( tr( "OpenFile" ) );
    TextLabel11->setText( tr( "ProgressBar" ) );
    TextLabel18->setText( tr( "GoBack" ) );
    TextLabel16->setText( tr( "Bookmark" ) );
    TextLabel13->setText( tr( "Rotate" ) );
    settingsTab->changeTab( tab_5, tr( "Controls 1" ) );
    joypadCheckBox->setText( tr( "Use Joypad" ) );
    TextLabel20_2_2->setText( tr( "PageDown" ) );
    TextLabel22_2_2->setText( tr( "Right" ) );
    TextLabel19_2_2->setText( tr( "PageUp" ) );
    TextLabel21_2_2->setText( tr( "Left" ) );
    settingsTab->changeTab( tab_6, tr( "Controls 2" ) );
    textLabel3->setText( tr( "Just Reader\n"
"\n"
"Version 2.0\n"
"\n"
"Author: Dmitri Skachkov\n"
"d_skachkov@yahoo.com\n"
"\n"
"Licensed under\n"
"the GNU Public License\n"
"\n"
"Latest version at:\n"
"http://justreader.sourceforge.net\n"
"" ) );
    settingsTab->changeTab( tab_7, tr( "About" ) );
}


void SettingsDlg::joypadChanged()
{
    config.keys.joypad = joypadCheckBox->isChecked();
    upButton->setEnabled(!joypadCheckBox->isChecked());
    downButton->setEnabled(!joypadCheckBox->isChecked());
    leftButton->setEnabled(!joypadCheckBox->isChecked());
    rightButton->setEnabled(!joypadCheckBox->isChecked());
}

void SettingsDlg::keyPressEvent(QKeyEvent * e)
{
    switch (e->key())
    {
	    case Key_F33:
	    emit acceptSettings();
	    break;
	case Key_Return:
	    emit acceptSettings();
	    break;
	case Key_Escape:
	    emit closeSettings();
	    break;
	default:
	    e->ignore();
    }
}

void SettingsDlg::resizeEvent(QResizeEvent *)
{
    settingsTab->resize(size());
}

void SettingsDlg::showEvent ( QShowEvent * )
{
    int i;
    i = 0;
    while (i < fontNameComboBox->count())
    {
		fontNameComboBox->setCurrentItem(i++);
		if (fontNameComboBox->currentText() == config.display.fontName) break;
    }
    if (i > fontNameComboBox->count())
    {
		fontNameComboBox->setCurrentItem(0);
    }
    i = 0;
    while (i < encodingComboBox->count())
    {
    	encodingComboBox->setCurrentItem(i++);
	if (encodingComboBox->currentText() == config.format.encoding) break;
    }
    if (i > encodingComboBox->count())
    {
	encodingComboBox->setCurrentItem(0);
    }
    i = 0;
    while (i < rotationComboBox->count())
    {
    	rotationComboBox->setCurrentItem(i++);
	if (rotationComboBox->currentText() == QString().setNum(int(config.display.rotation))) break;
    }
    if (i > rotationComboBox->count())
    {
	rotationComboBox->setCurrentItem(0);
    }
    switch (config.format.docFormat)
    {
	case FORMAT_AUTO:
	    docFormatString = "Auto";
	    break;
	case FORMAT_HTML:
	    docFormatString = "HTML";
	    break;
	case FORMAT_XML:
	    docFormatString = "XML";
	    break;
	case FORMAT_TXT:
	    docFormatString = "TXT";
	    break;
	default:
	    docFormatString = "TXT";
	    break;
    }
    i = 0;
    while (i < docFormatComboBox->count())
    {
	docFormatComboBox->setCurrentItem(i++);
	if (docFormatComboBox->currentText() == docFormatString) break;
    }
    if (i>docFormatComboBox->count())
    {
	docFormatComboBox->setCurrentItem(0);
    }
    switch (config.format.palmFormat)
    {
	case FORMAT_PALM_PLUCKER:
	    palmFormatString = "Plucker";
	    break;
	case FORMAT_PALM_DOC:
	    palmFormatString = "DOC";
	    break;
	case FORMAT_PALM_HTML:
	    palmFormatString = "HTML";
	    break;
	case FORMAT_PALM_TXT:
	    palmFormatString = "TXT";
	    break;
	case FORMAT_PALM_MOBIPOCKET:
	    palmFormatString = "MobiPocket";
	    break;
	default:
	    palmFormatString = "TXT";
	    break;
    }

    i = 0;
    while (i < palmFormatComboBox->count())
    {
	palmFormatComboBox->setCurrentItem(i++);
	if (palmFormatComboBox->currentText() == palmFormatString) break;
    }
    if (i>palmFormatComboBox->count())
    {
	palmFormatComboBox->setCurrentItem(0);
    }

	
    /*while (i < paragraphRegexpComboBox->count())
    {
    	paragraphRegexpComboBox->setCurrentItem(i++);
	if (paragraphRegexpComboBox->currentText() == paragraphRegexp) break;
    }
    if (i > paragraphRegexpComboBox->count())
    {
	paragraphRegexpComboBox->setCurrentItem(0);
    }*/
    if (config.display.defaultAlign == 0)
    {
	alignString = "Left";
    } else if (config.display.defaultAlign == 1)
    {
	alignString = "Center";
    } else if (config.display.defaultAlign == 2)
    {
	alignString = "Right";
    } else {
	alignString = "Justify";
    }
    i = 0;
    while (i < alignComboBox->count())
    {
    	alignComboBox->setCurrentItem(i++);
	if (alignComboBox->currentText() == alignString) break;
    }
    if (i > alignComboBox->count())
    {
	alignComboBox->setCurrentItem(0);
    }


    fontSizeSpinBox->setValue(config.display.fontSize);
    fontBoldCheckBox->setChecked(config.display.fontBold);
    fakeBoldCheckBox->setChecked(config.display.fakeBold);
    fontItalicCheckBox->setChecked(config.display.fontItalic);
    //justifyCheckBox->setChecked(justify);
    reparagraphCheckBox->setChecked(config.format.reparagraph);
    removeSpacePadsCheckBox->setChecked(config.format.removeSpacePads);
    separateParagraphsCheckBox->setChecked(config.format.separateParagraphs);
    stripCRCheckBox->setChecked(config.format.stripCR);
    reorderPluckerCheckBox->setChecked(config.format.reorderPlucker);
    barCheckBox->setChecked(config.display.barVisible);
    barPercentCheckBox->setChecked(config.display.barPercent);
    indentSpinBox->setValue(config.display.indentPoints);
    marginsSpinBox->setValue(config.display.margin);
    spacingSpinBox->setValue(config.display.spacing);
    overlapSpinBox->setValue(config.display.overlap);
    imageScalingSpinBox->setValue(config.display.imageScaling);
    imageAsWordCheckBox->setChecked(config.display.imageAsWord);
    scrollSpinBox->setValue(config.display.scrollDelay);
    intDictCheckBox->setChecked(config.misc.intDict);
    dictionaryLineEdit->setText(config.misc.dictionary);
    QFileInfo fileinfo(config.misc.dictionary);
    setFolderList(fileinfo.dirPath(true));
    //boxAll->resize(width(),height());
    bgColorComboBox->setCurrentColor(config.colors.bgColor);
    normalColorComboBox->setCurrentColor(config.colors.normalColor);
    linkColorComboBox->setCurrentColor(config.colors.linkColor);
    barBgColorComboBox->setCurrentColor(config.colors.barBgColor);
    barFgColorComboBox->setCurrentColor(config.colors.barFgColor);
    barTextColorComboBox->setCurrentColor(config.colors.barTextColor);


    scrollButton->setCurrentKey(config.keys.scroll);
    barButton->setCurrentKey(config.keys.bar);
    fullScreenButton->setCurrentKey(config.keys.fullScreen);
    rotateButton->setCurrentKey(config.keys.rotate);
    settingsButton->setCurrentKey(config.keys.settings);
    fileopenButton->setCurrentKey(config.keys.fileopen);
    bookmarkButton->setCurrentKey(config.keys.bookmark);
    findButton->setCurrentKey(config.keys.find);
    backButton->setCurrentKey(config.keys.back);
    upButton->setCurrentKey(config.keys.up);
    downButton->setCurrentKey(config.keys.down);
    leftButton->setCurrentKey(config.keys.left);
    rightButton->setCurrentKey(config.keys.right);
    joypadCheckBox->setChecked(config.keys.joypad);
    joypadChanged();
    settingsTab->resize(width(),height());
    //dictionaryButton->adjustSize();	
}

//void SettingsDlg::hideEvent(QHideEvent *)
void SettingsDlg::acceptChanges()
{
    config.display.fontName = fontNameComboBox->currentText();
    config.format.encoding = encodingComboBox->currentText();
    config.display.rotation = rotationComboBox->currentText().toDouble();
    docFormatString = docFormatComboBox->currentText();
    if (docFormatString == "Auto") config.format.docFormat = FORMAT_AUTO;
    else if (docFormatString == "HTML") config.format.docFormat = FORMAT_HTML;
    else if (docFormatString == "XML") config.format.docFormat = FORMAT_XML;
    else if (docFormatString == "TXT") config.format.docFormat = FORMAT_TXT;
    else config.format.docFormat = FORMAT_TXT;
    palmFormatString = palmFormatComboBox->currentText();
    if (palmFormatString == "Plucker") config.format.palmFormat = FORMAT_PALM_PLUCKER;
    else if (palmFormatString == "HTML") config.format.palmFormat = FORMAT_PALM_HTML;
    else if (palmFormatString == "DOC") config.format.palmFormat = FORMAT_PALM_DOC;
    else if (palmFormatString == "TXT") config.format.palmFormat = FORMAT_PALM_TXT;
    else if (palmFormatString == "MobiPocket") config.format.palmFormat = FORMAT_PALM_MOBIPOCKET;
    else config.format.palmFormat = FORMAT_PALM_DOC;

    config.display.fontSize = fontSizeSpinBox->value();
    config.display.fontBold = fontBoldCheckBox->isChecked();
    config.display.fakeBold = fakeBoldCheckBox->isChecked();
    config.display.fontItalic = fontItalicCheckBox->isChecked();
    //justify = justifyCheckBox->isChecked();
    alignString = alignComboBox->currentText();
    if (alignString == "Left")
    {
	config.display.defaultAlign = 0;
    } else if (alignString == "Center")
    {
	config.display.defaultAlign = 1;
    } else if (alignString == "Right")
    {
	config.display.defaultAlign = 2;
    } else {
	config.display.defaultAlign = 3;
    }
    config.format.reparagraph = reparagraphCheckBox->isChecked();
    //paragraphRegexp = paragraphRegexpComboBox->currentText();
    config.format.removeSpacePads = removeSpacePadsCheckBox->isChecked();
    config.format.separateParagraphs = separateParagraphsCheckBox->isChecked();
    config.format.stripCR = stripCRCheckBox->isChecked();
    config.format.reorderPlucker = reorderPluckerCheckBox->isChecked();
    config.display.barVisible = barCheckBox->isChecked();
    config.display.barPercent = barPercentCheckBox->isChecked();
    config.display.indentPoints = indentSpinBox->value();
    config.display.margin = marginsSpinBox->value();
    config.display.spacing = spacingSpinBox->value();
    config.display.overlap = overlapSpinBox->value();
    config.display.imageScaling = imageScalingSpinBox->value();
    config.display.imageAsWord = imageAsWordCheckBox->isChecked();
    config.display.scrollDelay = scrollSpinBox->value();
    config.misc.intDict =  intDictCheckBox->isChecked();
    config.misc.dictionary = dictionaryLineEdit->text();
    config.colors.bgColor = bgColorComboBox->color;
    config.colors.normalColor = normalColorComboBox->color;
    config.colors.linkColor = linkColorComboBox->color;
    config.colors.barBgColor = barBgColorComboBox->color;
    config.colors.barFgColor = barFgColorComboBox->color;
    config.colors.barTextColor = barTextColorComboBox->color;
    config.keys.scroll = scrollButton->key;
    config.keys.bar = barButton->key;
    config.keys.fullScreen = fullScreenButton->key;
    config.keys.rotate = rotateButton->key;
    config.keys.settings = settingsButton->key;
    config.keys.fileopen = fileopenButton->key;
    config.keys.bookmark = bookmarkButton->key;
    config.keys.find = findButton->key;
    config.keys.back = backButton->key;
    config.keys.up = upButton->key;
    config.keys.down = downButton->key;
    config.keys.left = leftButton->key;
    config.keys.right = rightButton->key;
}

void SettingsDlg::setFolderList(QString folder)
{
    QDir dir;
    dictComboBox->clear();
#ifdef __FOR_QT__
    QPixmap p;
    p.load("folder");
    dictComboBox->insertItem(p,folder);
    dictComboBox->insertItem(p,"..");
#else
    dictComboBox->insertItem(Resource::loadPixmap("folder"),folder);
    dictComboBox->insertItem(Resource::loadPixmap("folder"),"..");
#endif
    dir.setPath(folder);
    if (!dir.exists()) dir.setPath(dir.homeDirPath());
    currentPath = dir.absPath();
    dir.setSorting(QDir::Name|QDir::DirsFirst|QDir::IgnoreCase);
    const QFileInfoList * filelist = dir.entryInfoList();
    QFileInfoListIterator it(*filelist);
    QFileInfo * fi;
    while( (fi=it.current()) != 0 )
    {
	++it;
	 if ( fi->fileName() == ".")
	     ;
	 else if ( fi->fileName() == "..")
	 {
	     ;//dictComboBox->insertItem("..");
	 }
	 else if ( fi->fileName() == "NotAvailable")
	 {
	     dictComboBox->insertItem("..");
	 }
	 else if ( fi->isDir())
	 {
#ifdef __FOR_QT__
	     p.load("folder");
	     dictComboBox->insertItem(p,fi->fileName());
#else
	     dictComboBox->insertItem(Resource::loadPixmap("folder"),fi->fileName());
#endif
	 }
	 else
	 {
#ifdef __FOR_QT__
	     p.load("DocsIcon");
	     if ((fi->fileName().find(QRegExp("\\.dic$"),0))>-1) dictComboBox->insertItem(p,fi->fileName());
	     if ((fi->fileName().find(QRegExp("\\.dic\\.dz$"),0))>-1) dictComboBox->insertItem(p,fi->fileName());
#else
	     if ((fi->fileName().find(QRegExp("\\.dic$"),0))>-1) dictComboBox->insertItem(Resource::loadPixmap("DocsIcon"),fi->fileName());
	     if ((fi->fileName().find(QRegExp("\\.dic\\.dz$"),0))>-1) dictComboBox->insertItem(Resource::loadPixmap("DocsIcon"),fi->fileName());
#endif
	 }
    }

} 

void SettingsDlg::pathChanged(const QString &filename)
{
    QDir dir(currentPath);
    if (currentPath == filename) return;
    QFileInfo fileinfo(currentPath+"/"+filename);
    if (fileinfo.isDir())
    {
	dir.cd(filename);
	setFolderList(dir.absPath());
    } else {
	dictionaryLineEdit->setText(currentPath+"/"+filename);	
    }
}

void SettingsDlg::dictBrowse()
{
}
